package com.ekexiu.console.system.service;

import com.ekexiu.console.system.mail.MailService;
import org.apache.log4j.Logger;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;

import javax.mail.MessagingException;
import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/5/11.
 */
@Path
public class EmailService {
    private Logger logger = Logger.getLogger(EmailService.class);

    @Autowrie
    private MailService mailservice;

    private String phoneContentTemplate;

    private String content = "contentKey";
    private String contentDefault = "科袖网是一个为科研工作者服务的平台。我们将为您免费提供一个专属主页，您可以对外展示您的科研经历、成果以及资源，我们的平台将面向全国的企业与科研机构进行推广，您将得到更多与企业的合作、与同行交流的机会。";

    private String appellation = "appellationKey";
    private String appellationDefault = "您好";

    private String phoneReplaceKey = "mobileCode";
    private String inviteReplacePhone = "phoneKey";
    private String inviteReplaceEmail = "mailKey";
    private String inviteReplaceCode = "invitCodeKey";
    private String inviteMailSubject = "[ 科袖网 ]特邀科研专家邀请函";
    private String inviteMailContentTempalte;

    public String getAppellation() {
        return appellation;
    }

    public void setAppellation(String appellation) {
        this.appellation = appellation;
    }

    public String getAppellationDefault() {
        return appellationDefault;
    }

    public void setAppellationDefault(String appellationDefault) {
        this.appellationDefault = appellationDefault;
    }

    public String getContentDefault() {
        return contentDefault;
    }

    public void setContentDefault(String contentDefault) {
        this.contentDefault = contentDefault;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public MailService getMailservice() {
        return mailservice;
    }

    public void setMailservice(MailService mailservice) {
        this.mailservice = mailservice;
    }

    public String getPhoneContentTemplate() {
        return phoneContentTemplate;
    }

    public void setPhoneContentTemplate(String phoneContentTemplate) {
        this.phoneContentTemplate = phoneContentTemplate;
    }

    public String getPhoneReplaceKey() {
        return phoneReplaceKey;
    }

    public void setPhoneReplaceKey(String phoneReplaceKey) {
        this.phoneReplaceKey = phoneReplaceKey;
    }

    public String getInviteReplacePhone() {
        return inviteReplacePhone;
    }

    public void setInviteReplacePhone(String inviteReplacePhone) {
        this.inviteReplacePhone = inviteReplacePhone;
    }

    public String getInviteReplaceEmail() {
        return inviteReplaceEmail;
    }

    public void setInviteReplaceEmail(String inviteReplaceEmail) {
        this.inviteReplaceEmail = inviteReplaceEmail;
    }

    public String getInviteReplaceCode() {
        return inviteReplaceCode;
    }

    public void setInviteReplaceCode(String inviteReplaceCode) {
        this.inviteReplaceCode = inviteReplaceCode;
    }

    public String getInviteMailSubject() {
        return inviteMailSubject;
    }

    public void setInviteMailSubject(String inviteMailSubject) {
        this.inviteMailSubject = inviteMailSubject;
    }

    public String getInviteMailContentTempalte() {
        return inviteMailContentTempalte;
    }

    public void setInviteMailContentTempalte(String inviteMailContentTempalte) {
        this.inviteMailContentTempalte = inviteMailContentTempalte;
    }

    /**
     * 给指定邮箱发送邀请邮件
     *
     * @param con
     * @param mobilePhones 手机号数组
     * @param emails       邮箱
     * @param inviteCodes  邀请码
     * @throws SQLException
     * @throws MessagingException
     */
    @Post
    @Path("/sendmail")
    public int sendmail(@Nullable String content,@Nullable String appellation, @Nullable String[] mobilePhones, String[] emails, String[] inviteCodes)
            throws SQLException, MessagingException {
        for (int i = 0; i < emails.length; i++) {
            if (mobilePhones[i] == "") {
                mobilePhones[i] = null;
            }
            if (content == null) {
                content = this.contentDefault;
            }
            if (appellation == null) {
                appellation = this.appellationDefault;
            }
            this.sendInviteMail(content, appellation,emails[i], mobilePhones[i], inviteCodes[i]);
            this.logger.info("成功发送邀请邮件:" + emails[i]);
        }
        return emails.length;
    }

    public void sendInviteMail(String content,String appellation,String email, @Nullable String mobilePhone, String inviteCode)
            throws MessagingException {
        String mailContent = this.inviteMailContentTempalte;
        mailContent = mailContent.replaceAll(this.inviteReplaceEmail, email);
        mailContent = mailContent.replaceAll(this.inviteReplaceCode, inviteCode);
        mailContent = mailContent.replaceAll(this.appellation, appellation);
        mailContent = mailContent.replaceAll(this.content, content);
        String phoneReplace = "";
        if (mobilePhone != null && mobilePhone.trim().length() == 11) {
            String mobile = mobilePhone.trim();
            mobile = mobile.substring(0, 3) + "****" + mobile.substring(7);
            phoneReplace = this.phoneContentTemplate.replaceAll(this.phoneReplaceKey, mobile);
        }
        mailContent = mailContent.replaceAll(this.inviteReplacePhone, phoneReplace);
        this.mailservice.sendSimpleMail(email, mailContent, null, this.inviteMailSubject);
    }

}
